#pragma once
#include "util/flag-group.h"

enum class AttributeType : int {
    NONE = 0,
    ELEC = 1, /*!< 魔法効果: 電撃*/
    POIS = 2, /*!< 魔法効果: 毒*/
    ACID = 3, /*!< 魔法効果: 酸*/
    COLD = 4, /*!< 魔法効果: 冷気*/
    FIRE = 5, /*!< 魔法効果: 火炎*/
    PSY_SPEAR = 9, /*!< 魔法効果: 光の剣*/
    MISSILE = 10, /*!< 魔法効果: 弱魔力*/
    DEBUG = 11, /*!< 魔法効果: デバッグ用必中属性*/
    PLASMA = 12, /*!< 魔法効果: プラズマ*/
    WATER = 14, /*!< 魔法効果: 水流*/
    LITE = 15, /*!< 魔法効果: 閃光*/
    DARK = 16, /*!< 魔法効果: 暗黒*/
    LITE_WEAK = 17, /*!< 魔法効果: 弱光*/
    DARK_WEAK = 18, /*!< 魔法効果: 弱暗*/
    SHARDS = 20, /*!< 魔法効果: 破片*/
    SOUND = 21, /*!< 魔法効果: 轟音*/
    CONFUSION = 22, /*!< 魔法効果: 混乱*/
    FORCE = 23, /*!< 魔法効果: フォース*/
    INERTIAL = 24, /*!< 魔法効果: 遅鈍*/
    MANA = 26, /*!< 魔法効果: 純粋魔力*/
    METEOR = 27, /*!< 魔法効果: 隕石*/
    ICE = 28, /*!< 魔法効果: 極寒*/
    CHAOS = 30, /*!< 魔法効果: カオス*/
    NETHER = 31, /*!< 魔法効果: 地獄*/
    DISENCHANT = 32, /*!< 魔法効果: 劣化*/
    NEXUS = 33, /*!< 魔法効果: 因果混乱*/
    TIME = 34, /*!< 魔法効果: 時間逆転*/
    GRAVITY = 35, /*!< 魔法効果: 重力*/
    KILL_WALL = 40, /*!< 魔法効果: 岩石溶解*/
    KILL_DOOR = 41, /*!< 魔法効果: ドア破壊*/
    KILL_TRAP = 42, /*!< 魔法効果: トラップ破壊*/
    MAKE_WALL = 45, /*!< 魔法効果: 壁生成 (現在未使用)*/
    MAKE_DOOR = 46, /*!< 魔法効果: ドア生成*/
    MAKE_TRAP = 47, /*!< 魔法効果: トラップ生成*/
    MAKE_TREE = 48, /*!< 魔法効果: 森林生成*/
    OLD_CLONE = 51, /*!< 魔法効果: クローン・モンスター*/
    OLD_POLY = 52, /*!< 魔法効果: チェンジ・モンスター*/
    OLD_HEAL = 53, /*!< 魔法効果: 回復モンスター*/
    OLD_SPEED = 54, /*!< 魔法効果: スピード・モンスター*/
    OLD_SLOW = 55, /*!< 魔法効果: スロウ・モンスター*/
    OLD_CONF = 56, /*!< 魔法効果: パニック・モンスター*/
    OLD_SLEEP = 57, /*!< 魔法効果: スリープ・モンスター*/
    HYPODYNAMIA = 58, /*!< 魔法効果: 衰弱*/
    AWAY_UNDEAD = 61, /*!< 魔法効果: アンデッド・アウェイ*/
    AWAY_EVIL = 62, /*!< 魔法効果: 邪悪飛ばし*/
    AWAY_ALL = 63, /*!< 魔法効果: テレポート・アウェイ*/
    TURN_UNDEAD = 64, /*!< 魔法効果: アンデッド恐慌*/
    TURN_EVIL = 65, /*!< 魔法効果: 邪悪恐慌*/
    TURN_ALL = 66, /*!< 魔法効果: モンスター恐慌*/
    DISP_UNDEAD = 67, /*!< 魔法効果: アンデッド退散*/
    DISP_EVIL = 68, /*!< 魔法効果: 邪悪退散*/
    DISP_ALL = 69, /*!< 魔法効果: モンスター退散*/
    DISP_DEMON = 70, /*!< 魔法効果: 悪魔退散*/
    DISP_LIVING = 71, /*!< 魔法効果: 生命退散*/
    ROCKET = 72, /*!< 魔法効果: ロケット*/
    NUKE = 73, /*!< 魔法効果: 放射性廃棄物*/
    MAKE_RUNE_PROTECTION = 74, /*!< 魔法効果: 守りのルーン生成*/
    STASIS = 75, /*!< 魔法効果: モンスター拘束*/
    STONE_WALL = 76, /*!< 魔法効果: 壁生成*/
    DEATH_RAY = 77, /*!< 魔法効果: 死の光線*/
    STUN = 78, /*!< 魔法効果: 朦朧*/
    HOLY_FIRE = 79, /*!< 魔法効果: 聖光*/
    HELL_FIRE = 80, /*!< 魔法効果: 地獄の劫火*/
    DISINTEGRATE = 81, /*!< 魔法効果: 分解*/
    CHARM = 82, /*!< 魔法効果: モンスター魅了*/
    CONTROL_UNDEAD = 83, /*!< 魔法効果: アンデッド支配*/
    CONTROL_ANIMAL = 84, /*!< 魔法効果: 動物支配*/
    PSI = 85, /*!< 魔法効果: サイキック攻撃*/
    PSI_DRAIN = 86, /*!< 魔法効果: 精神吸収*/
    TELEKINESIS = 87, /*!< 魔法効果: テレキシネス*/
    JAM_DOOR = 88, /*!< 魔法効果: 施錠*/
    DOMINATION = 89, /*!< 魔法効果: 精神支配*/
    DISP_GOOD = 90, /*!< 魔法効果: 善良退散*/
    DRAIN_MANA = 91, /*!< 魔法効果: 魔力吸収*/
    MIND_BLAST = 92, /*!< 魔法効果: 精神攻撃*/
    BRAIN_SMASH = 93, /*!< 魔法効果: 脳攻撃*/
    CAUSE_1 = 94, /*!< 魔法効果: 軽傷の呪い*/
    CAUSE_2 = 95, /*!< 魔法効果: 重傷の呪い*/
    CAUSE_3 = 96, /*!< 魔法効果: 致命傷の呪い*/
    CAUSE_4 = 97, /*!< 魔法効果: 秘孔を突く*/
    HAND_DOOM = 98, /*!< 魔法効果: 破滅の手*/
    CAPTURE = 99, /*!< 魔法効果: 捕縛*/
    ANIM_DEAD = 100, /*!< 魔法効果: 死者復活*/
    CHARM_LIVING = 101, /*!< 魔法効果: 生命魅了*/
    IDENTIFY = 102, /*!< 魔法効果: 鑑定*/
    ATTACK = 103, /*!< 魔法効果: 白兵*/
    ENGETSU = 104, /*!< 魔法効果: 円月*/
    GENOCIDE = 105, /*!< 魔法効果: 抹殺*/
    PHOTO = 106, /*!< 魔法効果: 撮影*/
    CONTROL_DEMON = 107, /*!< 魔法効果: 悪魔支配*/
    LAVA_FLOW = 108, /*!< 魔法効果: 溶岩噴出*/
    BLOOD_CURSE = 109, /*!< 魔法効果: 血の呪い*/
    SEEKER = 110, /*!< 魔法効果: シーカーレイ*/
    SUPER_RAY = 111, /*!< 魔法効果: スーパーレイ*/
    STAR_HEAL = 112, /*!< 魔法効果: 星の癒し*/
    WATER_FLOW = 113, /*!< 魔法効果: 流水*/
    CRUSADE = 114, /*!< 魔法効果: 聖戦*/
    STASIS_EVIL = 115, /*!< 魔法効果: 邪悪拘束*/
    WOUNDS = 116, /*!< 魔法効果: 創傷*/
    E_GENOCIDE = 117, /*!< 魔法効果: 元素抹殺 */
    VOID_MAGIC = 118, /*!< 魔法効果: 虚無 */
    ABYSS = 119, /*!< 魔法効果: 深淵 */
    HUNGRY = 120, /*!< 魔法効果: 空腹>*/
    PLAYER_SHOOT = 121, /*!< 属性取得用: プレイヤーの射撃/投擲>*/
    PLAYER_MELEE = 122, /*!< 属性取得用: プレイヤーの近接攻撃>*/
    MONSTER_SHOOT = 123, /*!< 属性取得用: モンスターの射撃/投擲>*/
    MONSTER_MELEE = 124, /*!< 属性取得用: モンスターの近接攻撃>*/
    MAX /*!< 欠番を無視した最大サイズ (直上の値+1) */
};

/*! 属性フラグATTRIBUTEの集合を表すクラス */
using AttributeFlags = FlagGroup<AttributeType, AttributeType::MAX>;
