#pragma once

/*!
 * @note モンスターの攻撃効果 / New monster blow effects
 *
 * "Race Blow Effect" の略。
 * 実装の都合上、0 から始まる連番でなければならない。
 */
enum class RaceBlowEffectType : int {
    NONE = 0,
    HURT = 1, /*!< モンスターの攻撃効果: 攻撃する*/
    POISON = 2, /*!< モンスターの攻撃効果: 毒をくらわす*/
    UN_BONUS = 3, /*!< モンスターの攻撃効果: 劣化させる*/
    UN_POWER = 4, /*!< モンスターの攻撃効果: 充填魔力を吸収する*/
    EAT_GOLD = 5, /*!< モンスターの攻撃効果: 金を盗む*/
    EAT_ITEM = 6, /*!< モンスターの攻撃効果: アイテムを盗む*/
    EAT_FOOD = 7, /*!< モンスターの攻撃効果: あなたの食糧を食べる*/
    EAT_LITE = 8, /*!< モンスターの攻撃効果: 明かりを吸収する*/
    ACID = 9, /*!< モンスターの攻撃効果: 酸を飛ばす*/
    ELEC = 10, /*!< モンスターの攻撃効果: 感電させる*/
    FIRE = 11, /*!< モンスターの攻撃効果: 燃やす*/
    COLD = 12, /*!< モンスターの攻撃効果: 凍らせる*/
    BLIND = 13, /*!< モンスターの攻撃効果: 盲目にする*/
    CONFUSE = 14, /*!< モンスターの攻撃効果: 混乱させる*/
    TERRIFY = 15, /*!< モンスターの攻撃効果: 恐怖させる*/
    PARALYZE = 16, /*!< モンスターの攻撃効果: 麻痺させる*/
    LOSE_STR = 17, /*!< モンスターの攻撃効果: 腕力を減少させる*/
    LOSE_INT = 18, /*!< モンスターの攻撃効果: 知能を減少させる*/
    LOSE_WIS = 19, /*!< モンスターの攻撃効果: 賢さを減少させる*/
    LOSE_DEX = 20, /*!< モンスターの攻撃効果: 器用さを減少させる*/
    LOSE_CON = 21, /*!< モンスターの攻撃効果: 耐久力を減少させる*/
    LOSE_CHR = 22, /*!< モンスターの攻撃効果: 魅力を減少させる*/
    LOSE_ALL = 23, /*!< モンスターの攻撃効果: 全ステータスを減少させる*/
    SHATTER = 24, /*!< モンスターの攻撃効果: 粉砕する*/
    EXP_10 = 25, /*!< モンスターの攻撃効果: 経験値を減少(10d6+)させる*/
    EXP_20 = 26, /*!< モンスターの攻撃効果: 経験値を減少(20d6+)させる*/
    EXP_40 = 27, /*!< モンスターの攻撃効果: 経験値を減少(40d6+)させる*/
    EXP_80 = 28, /*!< モンスターの攻撃効果: 経験値を減少(80d6+)させる*/
    DISEASE = 29, /*!< モンスターの攻撃効果: 病気にする*/
    TIME = 30, /*!< モンスターの攻撃効果: 時間を逆戻りさせる*/
    DR_LIFE = 31, /*!< モンスターの攻撃効果: 生命力を吸収する*/
    DR_MANA = 32, /*!< モンスターの攻撃効果: 魔力を奪う*/
    SUPERHURT = 33, /*!< モンスターの攻撃効果: 強力に攻撃する*/
    INERTIA = 34, /*!< モンスターの攻撃効果: 減速させる*/
    STUN = 35, /*!< モンスターの攻撃効果: 朦朧とさせる*/
    FLAVOR = 36, /*!< モンスターの攻撃効果: フレーバー(メッセージ表示のみ) */
    HUNGRY = 37, /*!< モンスターの攻撃効果: 空腹を進行させる*/
    CHAOS = 38, /*!< モンスターの攻撃効果: カオスを呼び起こす*/

    MAX, /*!< 最大値 */
};
