#include "store/store-owners.h"
#include "player-info/race-types.h"
#include "store/store-util.h"

const std::unordered_map<StoreSaleType, std::vector<owner_type>> owners = {
    { StoreSaleType::GENERAL,
        {
            { _("憶病者ラストリン", "Raistlin the Chicken"), 30000, 108, PlayerRaceType::HUMAN },
            { _("フレンドリーなビルボ", "Bilbo the Friendly"), 30000, 108, PlayerRaceType::HOBBIT, STORE_OBJ_STD_LEVEL },
            { _("憶病者リンスウィンド", "Rincewind the Chicken"), 30000, 108, PlayerRaceType::HUMAN, STORE_OBJ_STD_LEVEL },
            { _("背の低いサルタン", "Sultan the Midget"), 30000, 107, PlayerRaceType::GNOME, STORE_OBJ_STD_LEVEL },
            { _("ハンサムなライア=エル", "Lyar-el the Comely"), 30000, 107, PlayerRaceType::ELF, STORE_OBJ_STD_LEVEL },
            { _("親切なファリルマウエン", "Falilmawen the Friendly"), 30000, 108, PlayerRaceType::HOBBIT, STORE_OBJ_STD_LEVEL },
            { _("臆病者ヴォワラン", "Voirin the Cowardly"), 30000, 108, PlayerRaceType::HUMAN, STORE_OBJ_STD_LEVEL },
            { _("チビのエラシュナク", "Erashnak the Midget"), 30000, 107, PlayerRaceType::BEASTMAN, STORE_OBJ_STD_LEVEL },
            { _("ハンサムなグラッグ", "Grug the Comely"), 30000, 107, PlayerRaceType::HALF_TITAN, STORE_OBJ_STD_LEVEL },
            { _("ケチなフォロビア", "Forovir the Cheap"), 30000, 108, PlayerRaceType::HUMAN, STORE_OBJ_STD_LEVEL },
            { _("馬鹿のエリス", "Ellis the Fool"), 30000, 108, PlayerRaceType::HUMAN, STORE_OBJ_STD_LEVEL },
            { _("腹ペコのフィルバート", "Filbert the Hungry"), 30000, 107, PlayerRaceType::VAMPIRE, STORE_OBJ_STD_LEVEL },
            { _("スナーグル・サシグア", "Fthnargl Psathiggua"), 30000, 107, PlayerRaceType::MIND_FLAYER, STORE_OBJ_STD_LEVEL },
            { _("長死きエロワーズ", "Eloise the Long-Dead"), 30000, 108, PlayerRaceType::SPECTRE, STORE_OBJ_STD_LEVEL },
            { _("ノロマのフンディ", "Fundi the Slow"), 30000, 108, PlayerRaceType::ZOMBIE, STORE_OBJ_STD_LEVEL },
            { _("グランサス", "Granthus"), 30000, 107, PlayerRaceType::SKELETON, STORE_OBJ_STD_LEVEL },
            { _("丁寧なロラックス", "Lorax the Suave"), 30000, 107, PlayerRaceType::VAMPIRE, STORE_OBJ_STD_LEVEL },
            { _("ブッチ", "Butch"), 30000, 108, PlayerRaceType::HALF_ORC, STORE_OBJ_STD_LEVEL },
            { _("美しきエルベレス", "Elbereth the Beautiful"), 30000, 108, PlayerRaceType::HIGH_ELF, STORE_OBJ_STD_LEVEL },
            { _("こそこそサーレス", "Sarleth the Sneaky"), 30000, 107, PlayerRaceType::GNOME, STORE_OBJ_STD_LEVEL },
            { _("ナーロック", "Narlock"), 30000, 107, PlayerRaceType::DWARF, STORE_OBJ_STD_LEVEL },
            { _("チビのヘイネッカ", "Haneka the Small"), 30000, 108, PlayerRaceType::GNOME, STORE_OBJ_STD_LEVEL },
            { _("きちがいロワラン", "Loirin the Mad"), 30000, 108, PlayerRaceType::HALF_GIANT, STORE_OBJ_STD_LEVEL },
            { _("毒息のウート", "Wuto the Poisonbreath"), 30000, 107, PlayerRaceType::DRACONIAN, STORE_OBJ_STD_LEVEL },
            { _("でぶっちょアラァカ", "Araaka the Rotund"), 30000, 107, PlayerRaceType::DRACONIAN, STORE_OBJ_STD_LEVEL },
            { _("低能なプーゴー", "Poogor the Dumb"), 30000, 108, PlayerRaceType::BEASTMAN, STORE_OBJ_STD_LEVEL },
            { _("フェロールフィリアン", "Felorfiliand"), 30000, 108, PlayerRaceType::ELF, STORE_OBJ_STD_LEVEL },
            { _("年寄りマロカ", "Maroka the Aged"), 30000, 107, PlayerRaceType::GNOME, STORE_OBJ_STD_LEVEL },
            { _("勇敢なサシン", "Sasin the Bold"), 30000, 107, PlayerRaceType::HALF_GIANT, STORE_OBJ_STD_LEVEL },
            { _("田舎者アビエマール", "Abiemar the Peasant"), 30000, 108, PlayerRaceType::HUMAN, STORE_OBJ_STD_LEVEL },
            { _("貧乏なハーク", "Hurk the Poor"), 30000, 108, PlayerRaceType::HALF_ORC, STORE_OBJ_STD_LEVEL },
            { _("みじめなソアリン", "Soalin the Wretched"), 30000, 107, PlayerRaceType::ZOMBIE, STORE_OBJ_STD_LEVEL },
            { _("質素なメルラ", "Merulla the Humble"), 30000, 107, PlayerRaceType::ELF, STORE_OBJ_STD_LEVEL },
        } },
    { StoreSaleType::ARMOURY,
        {
            { _("醜悪コン=ダー", "Kon-Dar the Ugly"), 30000, 115, PlayerRaceType::HALF_ORC, STORE_OBJ_STD_LEVEL },
            { _("頑固者ダーグ=ロウ", "Darg-Low the Grim"), 30000, 111, PlayerRaceType::HUMAN, STORE_OBJ_STD_LEVEL },
            { _("賢者デカド", "Decado the Handsome"), 30000, 112, PlayerRaceType::DUNADAN, STORE_OBJ_STD_LEVEL },
            { _("鍛冶屋のウィーランド", "Wieland the Smith"), 30000, 112, PlayerRaceType::DWARF, STORE_OBJ_STD_LEVEL },
            { _("ハンサムなデカド", "Decado the Handsome"), 30000, 112, PlayerRaceType::AMBERITE, STORE_OBJ_STD_LEVEL },
            { _("エロー・ドラゴンスケイル", "Elo Dragonscale"), 30000, 112, PlayerRaceType::ELF, STORE_OBJ_STD_LEVEL },
            { _("デリカトス", "Delicatus"), 30000, 115, PlayerRaceType::SPRITE, STORE_OBJ_STD_LEVEL },
            { _("巨大なグルース", "Gruce the Huge"), 30000, 111, PlayerRaceType::HALF_GIANT, STORE_OBJ_STD_LEVEL },
            { _("アニムス", "Animus"), 30000, 112, PlayerRaceType::GOLEM, STORE_OBJ_STD_LEVEL },
            { _("マルヴァス", "Malvus"), 30000, 112, PlayerRaceType::HALF_TITAN, STORE_OBJ_STD_LEVEL },
            { _("セラクシス", "Selaxis"), 30000, 115, PlayerRaceType::ZOMBIE, STORE_OBJ_STD_LEVEL },
            { _("デス・チル", "Deathchill"), 30000, 111, PlayerRaceType::SPECTRE, STORE_OBJ_STD_LEVEL },
            { _("微かなドリオス", "Drios the Faint"), 30000, 112, PlayerRaceType::SPECTRE, STORE_OBJ_STD_LEVEL },
            { _("冷たいバスリック", "Bathric the Cold"), 30000, 112, PlayerRaceType::VAMPIRE, STORE_OBJ_STD_LEVEL },
            { _("冷酷ヴェンジェラ", "Vengella the Cruel"), 30000, 115, PlayerRaceType::HALF_TROLL, STORE_OBJ_STD_LEVEL },
            { _("強者ウィラナ", "Wyrana the Mighty"), 30000, 111, PlayerRaceType::HUMAN, STORE_OBJ_STD_LEVEL },
            { _("ヨジョ二世", "Yojo II"), 30000, 112, PlayerRaceType::DWARF, STORE_OBJ_STD_LEVEL },
            { _("優しいラナラー", "Ranalar the Sweet"), 30000, 112, PlayerRaceType::AMBERITE, STORE_OBJ_STD_LEVEL },
            { _("不浄のホルバグ", "Horbag the Unclean"), 30000, 115, PlayerRaceType::HALF_ORC, STORE_OBJ_STD_LEVEL },
            { _("テレパスのエレレン", "Elelen the Telepath"), 30000, 111, PlayerRaceType::DARK_ELF, STORE_OBJ_STD_LEVEL },
            { _("イスドリリアス", "Isedrelias"), 30000, 112, PlayerRaceType::SPRITE, STORE_OBJ_STD_LEVEL },
            { _("一つ目ヴェグナー", "Vegnar One-eye"), 30000, 112, PlayerRaceType::CYCLOPS, STORE_OBJ_STD_LEVEL },
            { _("混沌のロディッシュ", "Rodish the Chaotic"), 30000, 115, PlayerRaceType::BEASTMAN, STORE_OBJ_STD_LEVEL },
            { _("剣豪ヘジン", "Hesin Swordmaster"), 30000, 111, PlayerRaceType::NIBELUNG, STORE_OBJ_STD_LEVEL },
            { _("ずる屋のエルベレリス", "Elvererith the Cheat"), 30000, 112, PlayerRaceType::DARK_ELF, STORE_OBJ_STD_LEVEL },
            { _("インプのザサス", "Zzathath the Imp"), 30000, 112, PlayerRaceType::IMP, STORE_OBJ_STD_LEVEL },
        } },
    { StoreSaleType::WEAPON,
        {
            { _("残忍なるアーノルド", "Arnold the Beastly"), 30000, 115, PlayerRaceType::HALF_TROLL, STORE_OBJ_STD_LEVEL },
            { _("獣殺しのアーンダル", "Arndal the Beast-Slayer"), 30000, 110, PlayerRaceType::HALF_ELF, STORE_OBJ_STD_LEVEL },
            { _("獣マスターのエディー", "Eddie the Beast-Master"), 30000, 115, PlayerRaceType::HOBBIT, STORE_OBJ_STD_LEVEL },
            { _("竜殺しのオグライン", "Oglign the Dragon-Slayer"), 30000, 112, PlayerRaceType::DWARF, STORE_OBJ_STD_LEVEL },
            { _("熟練者ドリュー", "Drew the Skilled"), 30000, 115, PlayerRaceType::HUMAN, STORE_OBJ_STD_LEVEL },
            { _("龍の子オラックス", "Orrax the Dragonson"), 30000, 110, PlayerRaceType::DRACONIAN, STORE_OBJ_STD_LEVEL },
            { _("病気持ちのアンスラックス", "Anthrax the Disease-Carrier"), 30000, 115, PlayerRaceType::BEASTMAN, STORE_OBJ_STD_LEVEL },
            { _("頑丈者アルコス", "Arkhoth the Stout"), 30000, 112, PlayerRaceType::DWARF, STORE_OBJ_STD_LEVEL },
            { _("腐れ者のサリアス", "Sarlyas the Rotten"), 30000, 115, PlayerRaceType::ZOMBIE, STORE_OBJ_STD_LEVEL },
            { _("晒し骨のトゥエシク", "Tuethic the Bare-Bones"), 30000, 110, PlayerRaceType::SKELETON, STORE_OBJ_STD_LEVEL },
            { _("ビリオス", "Bilious"), 30000, 115, PlayerRaceType::BEASTMAN, STORE_OBJ_STD_LEVEL },
            { _("ファスガル", "Fasgul"), 30000, 112, PlayerRaceType::ZOMBIE, STORE_OBJ_STD_LEVEL },
            { _("パラディンのエレフリス", "Ellefris the Paladin"), 30000, 115, PlayerRaceType::BARBARIAN, STORE_OBJ_STD_LEVEL },
            { _("キ'トリッ'ク", "K'trrik'k"), 30000, 110, PlayerRaceType::KLACKON, STORE_OBJ_STD_LEVEL },
            { _("蜘蛛の友ドゥロカス", "Drocus the Spiderfriend"), 30000, 115, PlayerRaceType::DARK_ELF, STORE_OBJ_STD_LEVEL },
            { _("巨人殺しのフングス", "Fungus the Giant-Slayer"), 30000, 112, PlayerRaceType::DWARF, STORE_OBJ_STD_LEVEL },
            { _("デランサ", "Delantha"), 30000, 115, PlayerRaceType::ELF, STORE_OBJ_STD_LEVEL },
            { _("レンジャーのソルビスタニ", "Solvistani the Ranger"), 30000, 110, PlayerRaceType::HALF_ELF, STORE_OBJ_STD_LEVEL },
            { _("ノロマのゾリル", "Xoril the Slow"), 30000, 115, PlayerRaceType::GOLEM, STORE_OBJ_STD_LEVEL },
            { _("イーオン・フラックス", "Aeon Flux"), 30000, 112, PlayerRaceType::HALF_ELF, STORE_OBJ_STD_LEVEL },
            { _("強者ナドック", "Nadoc the Strong"), 30000, 115, PlayerRaceType::HOBBIT, STORE_OBJ_STD_LEVEL },
            { _("弱虫エラモグ", "Eramog the Weak"), 30000, 110, PlayerRaceType::KOBOLD, STORE_OBJ_STD_LEVEL },
            { _("公正なエオウィリス", "Eowilith the Fair"), 30000, 115, PlayerRaceType::VAMPIRE, STORE_OBJ_STD_LEVEL },
            { _("バルログ殺しのヒュイモグ", "Huimog the Balrog-Slayer"), 30000, 112, PlayerRaceType::HALF_ORC, STORE_OBJ_STD_LEVEL },
            { _("冷酷ピーダス", "Peadus the Cruel"), 30000, 115, PlayerRaceType::HUMAN, STORE_OBJ_STD_LEVEL },
            { _("殺し屋ヴァモグ", "Vamog the Slayer"), 30000, 110, PlayerRaceType::HALF_OGRE, STORE_OBJ_STD_LEVEL },
            { _("性悪フーシュナク", "Hooshnak the Vicious"), 30000, 115, PlayerRaceType::BEASTMAN, STORE_OBJ_STD_LEVEL },
            { _("舞闘家バレン", "Balenn the War-Dancer"), 30000, 112, PlayerRaceType::BARBARIAN, STORE_OBJ_STD_LEVEL },
        } },
    { StoreSaleType::TEMPLE,
        {
            { _("質素なルードヴィヒ", "Ludwig the Humble"), 30000, 109, PlayerRaceType::HUMAN, STORE_OBJ_STD_LEVEL },
            { _("パラディンのガンナー", "Gunnar the Paladin"), 30000, 110, PlayerRaceType::HUMAN, STORE_OBJ_STD_LEVEL },
            { _("選ばれしトリン", "Torin the Chosen"), 30000, 107, PlayerRaceType::ELF, STORE_OBJ_STD_LEVEL },
            { _("賢明なるサラストロ", "Sarastro the Wise"), 30000, 109, PlayerRaceType::DWARF, STORE_OBJ_STD_LEVEL },
            { _("パーシヴァル卿", "Sir Parsival the Pure"), 30000, 107, PlayerRaceType::HIGH_ELF, STORE_OBJ_STD_LEVEL },
            { _("神聖なるアセナス", "Asenath the Holy"), 30000, 109, PlayerRaceType::HUMAN, STORE_OBJ_STD_LEVEL },
            { _("マッキノン", "McKinnon"), 30000, 109, PlayerRaceType::HUMAN, STORE_OBJ_STD_LEVEL },
            { _("謹み婦人", "Mistress the Chastity"), 30000, 110, PlayerRaceType::HIGH_ELF, STORE_OBJ_STD_LEVEL },
            { _("ドルイドのハシュニック", "Hashnik the Druid"), 30000, 107, PlayerRaceType::HOBBIT, STORE_OBJ_STD_LEVEL },
            { _("フィナク", "Finak"), 30000, 109, PlayerRaceType::YEEK, STORE_OBJ_STD_LEVEL },
            { _("クリキック", "Finak"), 30000, 109, PlayerRaceType::KLACKON, STORE_OBJ_STD_LEVEL },
            { _("荒くれ者モリヴァル", "Morival the Wild"), 30000, 110, PlayerRaceType::ELF, STORE_OBJ_STD_LEVEL },
            { _("暗きホシャック", "Hoshak the Dark"), 30000, 107, PlayerRaceType::IMP, STORE_OBJ_STD_LEVEL },
            { _("賢者アタール", "Atal the Wise"), 30000, 109, PlayerRaceType::HUMAN, STORE_OBJ_STD_LEVEL },
            { _("清きイベニッド", "Ibenidd the Chaste"), 30000, 109, PlayerRaceType::HUMAN, STORE_OBJ_STD_LEVEL },
            { _("エリディシュ", "Eridish"), 30000, 110, PlayerRaceType::HALF_TROLL, STORE_OBJ_STD_LEVEL },
            { _("呪術師ヴルドゥシュ", "Vrudush the Shaman"), 30000, 107, PlayerRaceType::HALF_OGRE, STORE_OBJ_STD_LEVEL },
            { _("狂戦士ハオブ", "Haob the Berserker"), 30000, 109, PlayerRaceType::BARBARIAN, STORE_OBJ_STD_LEVEL },
            { _("若きプルーグディシュ", "Proogdish the Youthfull"), 30000, 109, PlayerRaceType::HALF_OGRE, STORE_OBJ_STD_LEVEL },
            { _("きちがいラムワイズ", "Lumwise the Mad"), 30000, 110, PlayerRaceType::YEEK, STORE_OBJ_STD_LEVEL },
            { _("有徳者ムワート", "Muirt the Virtuous"), 30000, 107, PlayerRaceType::KOBOLD, STORE_OBJ_STD_LEVEL },
            { _("弱虫ダードバード", "Dardobard the Weak"), 30000, 109, PlayerRaceType::SPECTRE, STORE_OBJ_STD_LEVEL },
        } },
    { StoreSaleType::ALCHEMIST,
        {
            { _("化学者マウザー", "Mauser the Chemist"), 30000, 111, PlayerRaceType::HALF_ELF, STORE_OBJ_STD_LEVEL },
            { _("カオスのウィズル", "Wizzle the Chaotic"), 30000, 110, PlayerRaceType::HOBBIT, STORE_OBJ_STD_LEVEL },
            { _("強欲ミダス", "Midas the Greedy"), 30000, 116, PlayerRaceType::GNOME, STORE_OBJ_STD_LEVEL },
            { _("貧弱ジャ=ファー", "Ja-Far the Alchemist"), 30000, 111, PlayerRaceType::ELF, STORE_OBJ_STD_LEVEL }, /*FIRST*/
            { _("カカルラカカル", "Kakalrakakal"), 30000, 116, PlayerRaceType::KLACKON, STORE_OBJ_STD_LEVEL },
            { _("錬金術師ジャル=エス", "Jal-Eth the Alchemist"), 30000, 111, PlayerRaceType::ELF, STORE_OBJ_STD_LEVEL },
            { _("用心深いファネラス", "Fanelath the Cautious"), 30000, 111, PlayerRaceType::DWARF, STORE_OBJ_STD_LEVEL },
            { _("キチガイのルンシー", "Runcie the Insane"), 30000, 110, PlayerRaceType::HUMAN, STORE_OBJ_STD_LEVEL },
            { _("グランブルワース", "Grumbleworth"), 30000, 116, PlayerRaceType::GNOME, STORE_OBJ_STD_LEVEL },
            { _("フリッター", "Flitter"), 30000, 111, PlayerRaceType::SPRITE, STORE_OBJ_STD_LEVEL },
            { _("ザリルス", "Xarillus"), 30000, 111, PlayerRaceType::HUMAN, STORE_OBJ_STD_LEVEL },
            { _("古きエグバート", "Egbert the Old"), 30000, 110, PlayerRaceType::DWARF, STORE_OBJ_STD_LEVEL },
            { _("誇り高きヴァリンドラ", "Valindra the Proud"), 30000, 116, PlayerRaceType::HIGH_ELF, STORE_OBJ_STD_LEVEL },
            { _("錬金術師タエン", "Taen the Alchemist"), 30000, 111, PlayerRaceType::HUMAN, STORE_OBJ_STD_LEVEL },
            { _("巧言カイド", "Cayd the Sweet"), 30000, 111, PlayerRaceType::VAMPIRE, STORE_OBJ_STD_LEVEL },
            { _("暗きフリア", "Fulir the Dark"), 30000, 110, PlayerRaceType::NIBELUNG, STORE_OBJ_STD_LEVEL },
            { _("質素なドムリ", "Domli the Humble"), 30000, 116, PlayerRaceType::DWARF, STORE_OBJ_STD_LEVEL },
            { _("魔の子ヤァジュッカ", "Yaarjukka Demonspawn"), 30000, 111, PlayerRaceType::IMP, STORE_OBJ_STD_LEVEL },
            { _("薬草師ジェララルドール", "Gelaraldor the Herbmaster"), 30000, 111, PlayerRaceType::HIGH_ELF, STORE_OBJ_STD_LEVEL },
            { _("賢者オレラルダン", "Olelaldan the Wise"), 30000, 110, PlayerRaceType::BARBARIAN, STORE_OBJ_STD_LEVEL },
            { _("デモニシストのフゾグロ", "Fthoglo the Demonicist"), 30000, 116, PlayerRaceType::IMP, STORE_OBJ_STD_LEVEL },
            { _("錬金術師ドゥリアシュ", "Dridash the Alchemist"), 30000, 111, PlayerRaceType::HALF_ORC, STORE_OBJ_STD_LEVEL },
            { _("強者ネリア", "Nelir the Strong"), 30000, 111, PlayerRaceType::CYCLOPS, STORE_OBJ_STD_LEVEL },
            { _("辛口リグナス", "Lignus the Pungent"), 30000, 110, PlayerRaceType::HALF_ORC, STORE_OBJ_STD_LEVEL },
            { _("ティルバ", "Tilba"), 30000, 116, PlayerRaceType::HOBBIT, STORE_OBJ_STD_LEVEL },
            { _("金持ちミリルドリック", "Myrildric the Wealthy"), 30000, 111, PlayerRaceType::HUMAN, STORE_OBJ_STD_LEVEL },
        } },
    { StoreSaleType::MAGIC,
        {
            { _("ソーサラーのロ=パン", "Lo Pan the Sorcerer"), 30000, 110, PlayerRaceType::HALF_ELF, STORE_OBJ_STD_LEVEL },
            { _("偉大なるブガービイ", "Buggerby the Great"), 30000, 113, PlayerRaceType::GNOME, STORE_OBJ_STD_LEVEL },
            { _("イェンダーの魔法使い", "The Wizard of Yendor"), 30000, 110, PlayerRaceType::HUMAN, STORE_OBJ_STD_LEVEL },
            { _("死霊使いリャク", "Rjak the Necromancer"), 30000, 110, PlayerRaceType::HIGH_ELF, STORE_OBJ_STD_LEVEL },
            { _("魔術師スキドゥニー", "Skidney the Sorcerer"), 30000, 110, PlayerRaceType::HALF_ELF, STORE_OBJ_STD_LEVEL },
            { _("幻術師キリア", "Kyria the Illusionist"), 30000, 110, PlayerRaceType::HUMAN, STORE_OBJ_STD_LEVEL },
            { _("死霊術師ニッキ", "Nikki the Necromancer"), 30000, 110, PlayerRaceType::DARK_ELF, STORE_OBJ_STD_LEVEL },
            { _("ソロストラン", "Solostoran"), 30000, 110, PlayerRaceType::SPRITE, STORE_OBJ_STD_LEVEL },
            { _("烏賊口アチシェ", "Achshe the Tentacled"), 30000, 113, PlayerRaceType::MIND_FLAYER, STORE_OBJ_STD_LEVEL },
            { _("貴族のカザ", "Kaza the Noble"), 30000, 110, PlayerRaceType::HIGH_ELF, STORE_OBJ_STD_LEVEL },
            { _("暗きファジル", "Fazzil the Dark"), 30000, 110, PlayerRaceType::DARK_ELF, STORE_OBJ_STD_LEVEL },
            { _("偉大なるケルドーン", "Keldorn the Grand"), 30000, 110, PlayerRaceType::DWARF, STORE_OBJ_STD_LEVEL },
            { _("フィランスロプス", "Philanthropus"), 30000, 113, PlayerRaceType::HOBBIT, STORE_OBJ_STD_LEVEL },
            { _("魔女のアグナー", "Agnar the Enchantress"), 30000, 110, PlayerRaceType::HUMAN, STORE_OBJ_STD_LEVEL },
            { _("死霊術師ビュリアンス", "Buliance the Necromancer"), 30000, 110, PlayerRaceType::BEASTMAN, STORE_OBJ_STD_LEVEL },
            { _("ハイメイジのヴイラク", "Vuirak the High-Mage"), 30000, 110, PlayerRaceType::BEASTMAN, STORE_OBJ_STD_LEVEL },
            { _("知恵者マディッシュ", "Madish the Smart"), 30000, 113, PlayerRaceType::BEASTMAN, STORE_OBJ_STD_LEVEL },
            { _("ファレブリンボール", "Falebrimbor"), 30000, 110, PlayerRaceType::HIGH_ELF, STORE_OBJ_STD_LEVEL },
            { _("陰険フェリル=ガンド", "Felil-Gand the Subtle"), 30000, 110, PlayerRaceType::DARK_ELF, STORE_OBJ_STD_LEVEL },
            { _("呪術師サレゴード", "Thalegord the Shaman"), 30000, 110, PlayerRaceType::BARBARIAN, STORE_OBJ_STD_LEVEL },
            { _("神秘家クトゥアロス", "Cthoaloth the Mystic"), 30000, 113, PlayerRaceType::MIND_FLAYER, STORE_OBJ_STD_LEVEL },
            { _("幻術師イベリ", "Ibeli the Illusionist"), 30000, 110, PlayerRaceType::SKELETON, STORE_OBJ_STD_LEVEL },
            { _("死霊術師ヘトー", "Heto the Necromancer"), 30000, 110, PlayerRaceType::YEEK, STORE_OBJ_STD_LEVEL },
        } },
    { StoreSaleType::BLACK,
        {
            { _("ガリー=ギガズ", "Gary Gygaz"), 60000, 150, PlayerRaceType::HALF_TROLL, STORE_OBJ_STD_LEVEL },
            { _("ゴブリンのヒストーア", "Histor the Goblin"), 60000, 150, PlayerRaceType::HALF_ORC, STORE_OBJ_STD_LEVEL },
            { _("フェレンギ人クアーク", "Quark the Ferengi"), 60000, 150, PlayerRaceType::HUMAN, STORE_OBJ_STD_LEVEL },
            { _("公正なる(?)トッピ", "Topi the Fair(?)"), 60000, 150, PlayerRaceType::ELF, STORE_OBJ_STD_LEVEL },
            { _("死人ヴァッサ", "Vhassa the Dead"), 60000, 150, PlayerRaceType::ZOMBIE, STORE_OBJ_STD_LEVEL },
            { _("裏切り者カイン", "Kyn the Treacherous"), 60000, 150, PlayerRaceType::VAMPIRE, STORE_OBJ_STD_LEVEL },
            { _("ブボニカス", "Bubonicus"), 60000, 150, PlayerRaceType::BEASTMAN, STORE_OBJ_STD_LEVEL },
            { _("コープスライト", "Corpselight"), 60000, 150, PlayerRaceType::SPECTRE, STORE_OBJ_STD_LEVEL },
            { _("血に飢えしパリッシュ", "Parrish the Bloodthirsty"), 60000, 150, PlayerRaceType::VAMPIRE, STORE_OBJ_STD_LEVEL },
            { _("ヴァイル", "Vile"), 60000, 150, PlayerRaceType::SKELETON, STORE_OBJ_STD_LEVEL },
            { _("信頼のプレンティス", "Prentice the Trusted"), 60000, 150, PlayerRaceType::SKELETON, STORE_OBJ_STD_LEVEL },
            { _("人間殺しのグリエラ", "Griella Humanslayer"), 60000, 150, PlayerRaceType::IMP, STORE_OBJ_STD_LEVEL },
            { _("エンジェル", "Angel"), 60000, 150, PlayerRaceType::VAMPIRE, STORE_OBJ_STD_LEVEL },
            { _("水膨れフロツァム", "Flotsam the Bloated"), 60000, 150, PlayerRaceType::ZOMBIE, STORE_OBJ_STD_LEVEL },
            { _("ニーヴァル", "Nieval"), 60000, 150, PlayerRaceType::VAMPIRE, STORE_OBJ_STD_LEVEL },
            { _("明るいアナスタシア", "Anastasia the Luminous"), 60000, 150, PlayerRaceType::SPECTRE, STORE_OBJ_STD_LEVEL },
            { _("死霊術師チャリティー", "Charity the Necromancer"), 60000, 150, PlayerRaceType::DARK_ELF, STORE_OBJ_STD_LEVEL },
            { _("ボクサーのプグナシオス", "Pugnacious the Pugilist"), 60000, 150, PlayerRaceType::HALF_ORC, STORE_OBJ_STD_LEVEL },
            { _("幸運なフットソア", "Footsore the Lucky"), 60000, 150, PlayerRaceType::BEASTMAN, STORE_OBJ_STD_LEVEL },
            { _("光指のシドリア", "Sidria the Lighfingered"), 60000, 150, PlayerRaceType::HUMAN, STORE_OBJ_STD_LEVEL },
            { _("手品師リアソー", "Riatho the Juggler"), 60000, 150, PlayerRaceType::HOBBIT, STORE_OBJ_STD_LEVEL },
            { _("やりくり上手のジャナッカ", "Janaaka the Shifty"), 60000, 150, PlayerRaceType::GNOME, STORE_OBJ_STD_LEVEL },
            { _("悪党シーナ", "Cina the Rogue"), 60000, 150, PlayerRaceType::GNOME, STORE_OBJ_STD_LEVEL },
            { _("大爪アルニッキ", "Arunikki the Greatclaw"), 60000, 150, PlayerRaceType::DRACONIAN, STORE_OBJ_STD_LEVEL },
            { _("貧乏チャエアンド", "Chaeand the Poor"), 60000, 150, PlayerRaceType::HUMAN, STORE_OBJ_STD_LEVEL },
            { _("山賊アファードーフ", "Afardorf the Brigand"), 60000, 150, PlayerRaceType::BARBARIAN, STORE_OBJ_STD_LEVEL },
            { _("強欲ラザクスル", "Lathaxl the Greedy"), 60000, 150, PlayerRaceType::MIND_FLAYER, STORE_OBJ_STD_LEVEL },
            { _("ファラレウィン", "Falarewyn"), 60000, 150, PlayerRaceType::SPRITE, STORE_OBJ_STD_LEVEL },
            { _("しわしわヴォスール", "Vosur the Wrinkled"), 60000, 150, PlayerRaceType::NIBELUNG, STORE_OBJ_STD_LEVEL },
            { _("ハンサムなアラオード", "Araord the Handsome"), 60000, 150, PlayerRaceType::AMBERITE, STORE_OBJ_STD_LEVEL },
            { _("負け犬セラドフリド", "Theradfrid the Loser"), 60000, 150, PlayerRaceType::HUMAN, STORE_OBJ_STD_LEVEL },
            { _("片足のエルーロ", "One-Legged Eroolo"), 60000, 150, PlayerRaceType::HALF_OGRE, STORE_OBJ_STD_LEVEL },
        } },
    { StoreSaleType::HOME,
        {
            { _("我が家", "Your home"), 0, 100, PlayerRaceType::HUMAN, STORE_OBJ_STD_LEVEL },
        } },
    { StoreSaleType::BOOK,
        {
            { _("強欲ドラフ", "Dolaf the Greedy"), 30000, 108, PlayerRaceType::HUMAN, STORE_OBJ_STD_LEVEL },
            { _("賢者オドナー", "Odnar the Sage"), 30000, 105, PlayerRaceType::HIGH_ELF, STORE_OBJ_STD_LEVEL },
            { _("中立のガンダー", "Gandar the Neutral"), 30000, 110, PlayerRaceType::DARK_ELF, STORE_OBJ_STD_LEVEL },
            { _("忍耐の人ロ=シャ", "Ro-sha the Patient"), 30000, 105, PlayerRaceType::ELF, STORE_OBJ_STD_LEVEL },
            { _("ランドルフ・カーター", "Randolph Carter"), 30000, 108, PlayerRaceType::HUMAN, STORE_OBJ_STD_LEVEL },
            { _("隼のサライ", "Sarai the Swift"), 30000, 108, PlayerRaceType::HUMAN, STORE_OBJ_STD_LEVEL },
            { _("千里眼ボドリル", "Bodril the Seer"), 30000, 105, PlayerRaceType::HIGH_ELF, STORE_OBJ_STD_LEVEL },
            { _("沈黙のヴェオロイン", "Veloin the Quiet"), 30000, 110, PlayerRaceType::ZOMBIE, STORE_OBJ_STD_LEVEL },
            { _("学者のヴァンシラス", "Vanthylas the Learned"), 30000, 105, PlayerRaceType::MIND_FLAYER, STORE_OBJ_STD_LEVEL },
            { _("物書きオセイン", "Ossein the Literate"), 30000, 108, PlayerRaceType::SKELETON, STORE_OBJ_STD_LEVEL },
            { _("本の虫オルヴァー", "Olvar Bookworm"), 30000, 105, PlayerRaceType::VAMPIRE, STORE_OBJ_STD_LEVEL },
            { _("浅井墓男", "Olvar Bookworm"), 30000, 110, PlayerRaceType::ZOMBIE, STORE_OBJ_STD_LEVEL },
            { _("デスマスク", "Death Mask"), 30000, 105, PlayerRaceType::ZOMBIE, STORE_OBJ_STD_LEVEL },
            { _("学者のアスーヌ", "Asuunu the Learned"), 30000, 108, PlayerRaceType::MIND_FLAYER, STORE_OBJ_STD_LEVEL },
            { _("死人のプリランド", "Prirand the Dead"), 30000, 105, PlayerRaceType::ZOMBIE, STORE_OBJ_STD_LEVEL },
            { _("鉄のロナール", "Ronar the Iron"), 30000, 110, PlayerRaceType::GOLEM, STORE_OBJ_STD_LEVEL },
            { _("ガリル=ガミル", "Galil-Gamir"), 30000, 105, PlayerRaceType::ELF, STORE_OBJ_STD_LEVEL },
            { _("本食いローバグ", "Rorbag the Book-Eater"), 30000, 108, PlayerRaceType::KOBOLD, STORE_OBJ_STD_LEVEL },
            { _("キリアリキーク", "Kiriarikirk"), 30000, 105, PlayerRaceType::KLACKON, STORE_OBJ_STD_LEVEL },
            { _("静かなるリリン", "Rilin the Quiet"), 30000, 110, PlayerRaceType::DWARF, STORE_OBJ_STD_LEVEL },
            { _("王者イサング", "Isung the Lord"), 30000, 105, PlayerRaceType::HIGH_ELF, STORE_OBJ_STD_LEVEL },
        } },
    { StoreSaleType::MUSEUM,
        {
            { _("博物館", "Museum"), 0, 100, PlayerRaceType::HUMAN, STORE_OBJ_STD_LEVEL },
        } }
};
