/*!
 * @brief ダンジョンID定義
 * @author Hourier
 * @date 2024/12/14
 */

#pragma once

#include "util/enum-range.h"

enum class DungeonId {
    WILDERNESS = 0,
    ANGBAND = 1,
    GALGALS = 2,
    ORC = 3,
    MAZE = 4,
    DRAGON = 5,
    GRAVE = 6,
    WOOD = 7,
    VOLCANO = 8,
    HELL = 9,
    HEAVEN = 10,
    OCEAN = 11,
    CASTLE = 12,
    CTH = 13,
    MOUNTAIN = 14,
    GOLD = 15,
    NO_MAGIC = 16,
    NO_MELEE = 17,
    CHAMELEON = 18,
    DARKNESS = 19,
    GLASS = 20,
    MAX,
};

constexpr EnumRange<DungeonId> DUNGEON_IDS(DungeonId::WILDERNESS, DungeonId::MAX);
