/*!
 * @brief 地形特性タグ
 * @author Hourier
 * @date 2024/12/08
 */

#pragma once

enum class TerrainTag {
    NONE,
    UNDETECTED,
    FLOOR,
    RUNE_PROTECTION,
    RUNE_EXPLOSION,
    MIRROR,
    UP_STAIR,
    DOWN_STAIR,
    ENTRANCE,
    RUBBLE,
    MAGMA_VEIN,
    QUARTZ_VEIN,
    GRANITE_WALL,
    PERMANENT_WALL,
    GLASS_FLOOR,
    GLASS_WALL,
    PERMANENT_GLASS_WALL,
    BLACK_MARKET,
    TOWN,
    DEEP_WATER,
    SHALLOW_WATER,
    DEEP_LAVA,
    SHALLOW_LAVA,
    HEAVY_COLD_ZONE,
    COLD_ZONE,
    HEAVY_ELECTRICAL_ZONE,
    ELECTRICAL_ZONE,
    DEEP_ACID_PUDDLE,
    SHALLOW_ACID_PUDDLE,
    DEEP_POISONOUS_PUDDLE,
    SHALLOW_POISONOUS_PUDDLE,
    DIRT,
    GRASS,
    BRAKE, //!< 草むら.
    FLOWER,
    TREE,
    MOUNTAIN,
    SWAMP,

    TRAP_TRAPDOOR,
    TRAP_PIT,
    TRAP_SPIKED_PIT,
    TRAP_POISON_PIT,
    TRAP_TY_CURSE,
    TRAP_TELEPORT,
    TRAP_FIRE,
    TRAP_ACID,
    TRAP_SLOW,
    TRAP_LOSE_STR,
    TRAP_LOSE_DEX,
    TRAP_LOSE_CON,
    TRAP_BLIND,
    TRAP_CONFUSE,
    TRAP_POISON,
    TRAP_SLEEP,
    TRAP_TRAPS,
    TRAP_ALARM,

    TRAP_OPEN,
    TRAP_PIRANHA,
    TRAP_ARMAGEDDON,

    PATTERN_START,
    PATTERN_1,
    PATTERN_2,
    PATTERN_3,
    PATTERN_4,
    PATTERN_END,
    PATTERN_OLD,
    PATTERN_EXIT,
    PATTERN_CORRUPTED,

    LOCKED_DOOR_1,
    LOCKED_DOOR_2,
    LOCKED_DOOR_3,
    LOCKED_DOOR_4,
    LOCKED_DOOR_5,
    LOCKED_DOOR_6,
    LOCKED_DOOR_7,

    JAMMED_DOOR_0,
    JAMMED_DOOR_1,
    JAMMED_DOOR_2,
    JAMMED_DOOR_3,
    JAMMED_DOOR_4,
    JAMMED_DOOR_5,
    JAMMED_DOOR_6,
    JAMMED_DOOR_7,

    LOCKED_GLASS_DOOR_1,
    LOCKED_GLASS_DOOR_2,
    LOCKED_GLASS_DOOR_3,
    LOCKED_GLASS_DOOR_4,
    LOCKED_GLASS_DOOR_5,
    LOCKED_GLASS_DOOR_6,
    LOCKED_GLASS_DOOR_7,

    JAMMED_GLASS_DOOR_0,
    JAMMED_GLASS_DOOR_1,
    JAMMED_GLASS_DOOR_2,
    JAMMED_GLASS_DOOR_3,
    JAMMED_GLASS_DOOR_4,
    JAMMED_GLASS_DOOR_5,
    JAMMED_GLASS_DOOR_6,
    JAMMED_GLASS_DOOR_7,

    OPEN_DOOR,
    BROKEN_DOOR,
    CLOSED_DOOR,
    OPEN_GLASS_DOOR,
    BROKEN_GLASS_DOOR,
    CLOSED_GLASS_DOOR,
    OPEN_CURTAIN,
    CLOSED_CURTAIN,
};
